
;************************    *********************

;*   - 8,0 
;* ;
;* Main:          
;* InitLCD:        
;* ReadADC:          ADC
;* Start:          
;* Measur_PT:     ,      
;* Sound:         
;* HexBCDmU:        BCD-
;* CalcPower:      
;* MUL42:         
;* DIV42:         
;* Data_DisplayUI:   ,   
;* Data_DisplayPT:   ,   
;* WarnI:		     ,   
;* WarnT:		     ,  
;* Microlan: 	    1Wire
;* ConvTemp:         
;* ReadTemp:        
;* CalcTherm:        
;* TempBCD:	          BCD-
;* CalcI:           
;*******************************************************************************

.nolist
.include "m8def.inc"
.list

;***** *****

.def	m0 = r1        ;     
.def	m1 = r2     
.def	m2 = r3      
.def	m3 = r4      
.def	m4 = r5      
.def	m5 = r6      
.def	m6 = r7
.def	m7 = r8
.def	CompL = r9     ;     
.def	CompH = r10    ;     
.def	hexL = r11     ;    
.def	hexH = r12     ;    
.def	tmp1 = r16     ;   
.def	tmp2 = r17     ;   
.def	tmp3 = r18     ;   
.def	prm1 = r19     ;  
.def	Cnt = r20      ;    
.def	tim1 = r21     ;   
.def	time = r22     ;                
.def	ThermJ = r23   ;     ( )
.def	ChoiceT = r24  ;    

;*****  *****

.equ  Ena  = 5	    ; Enable Impuls =  5  C
.equ  RS   = 3	    ; Register Select =  3  C
.equ  RW   = 4	    ; R/W =  4  C
.equ  BF   = 7	    ;   =  7  B
.equ  DQ   = 2	    ; 1WIRE -  2  C
.equ  Tmax = 140	;     

.equ  ADSM  = 0b11001110  ; ADEN=1,ADSC=1,ADIE=1,ADPS2=1,ADPS1=1,ADPS0=0, 125 
.equ  ADMXu = 0b11000001  ; REFS1=1,REFS0=1,Vref=2,56V,ADC1- 
.equ  ADMXi = 0b11000000  ; REFS1=1,REFS0=1,Vref=2,56V,ADC0- 
       

.cseg

.org 0
	rjmp Initial

.org  ADCCaddr           ;    ADC Complete
ldi   tmp3,0b00010000      ; SE=0 ( "" ), SM[2..0]=001
out   MCUCR,tmp3           ; ""  =  
reti

Initial: ;     	
	
	ldi   tmp1,High(RamEnd) 
    out   sph,tmp1
    ldi   tmp1,Low(RamEnd)
    out   spl,tmp1	      ;  
    ldi	tmp1,0b00011110 
	out	PORTD,tmp1        ; PD0-,PD1-,PD2- SB1 
	ldi	tmp1,0b00011010   ; PD2-HL1 . PD3-HL2 .	
	out	DDRD,tmp1	
    ldi   tmp1,0b00000000       
    out   PORTC,tmp1      ; RW,Ena,RS,= 0  
    ldi   tmp1,0b00111000	   
    out   DDRC,tmp1	      ; RW,Ena,RS=1
    clr   tmp1	       
    out   PortB,tmp1      ;   
    ser   tmp1	       
    out   DDRB,tmp1

    ldi tmp1,30          ;  >0,5 
	mov CompL,tmp1
    ldi tmp1,0 
    mov CompH,tmp1 

    clr ChoiceT

    ldi   tmp1,5	      ;  
    out   TCCR0,tmp1      ;  T/C2,  . = 1024

	rcall InitLCD         ;  -
	sei					  ;  
	rcall ReadCodID       ;  ID-    1-Wire 
	rjmp Start

;***********************************************************************************
;   8-  ,   .
;***********************************************************************************
SendCom:	;   - 
cbi   PortC,RS	; Register Select = 
rcall LoadData
ret

SendDat:	;   -  
sbi   PortC,RS	; Register Select =  
rcall LoadData
ret

LoadData:	;   = 8 
out   PortB,prm1;  /   B
sbi   PortC,Ena	;   
nop
nop	
nop
nop    	    ;     450 
cbi   PortC,Ena	;   
ret

WaitBusy:	;   -  
clr   tmp1
out   DDRB,tmp1	;  D = 
cbi   PortC,RS	; Register Select = 
sbi   PortC,RW	;  =   -
WB2:
sbi   PortC,Ena	;   
nop	
nop
nop	            ;  . 320   
in    tmp1,PinB	;  BF    
cbi   PortC,Ena	;   
nop
sbrc  tmp1,BF	;   ,  -  (BF=0)
rjmp  WB2
cbi   PortC,RW	;   =  -
ser   tmp1
out   DDRB,tmp1	;  B = 
ret

InitLCD:;   8-  

rcall wait5ms
rcall wait5ms
rcall wait5ms	;   20    
rcall wait5ms
ldi   prm1,$30	; $30:  , 8 
rcall SendCom	;    -
rcall wait50us	;   50 k
ldi   prm1,$30	; $30:  , 8 
rcall SendCom	;  
rcall wait50us	;   50 k
ldi   prm1,$30	; $30:  ,8  
rcall SendCom	;  
rcall wait50us	;   50 k
ldi   prm1,$38  ;  
rcall WaitBusy	;   -  
rcall SendCom	;    -
ldi   prm1,$08	; $08:  
rcall WaitBusy	;   -  
rcall SendCom	;  
ldi   prm1,$01	; $01:  
rcall WaitBusy	;   -  
rcall SendCom	;  
ldi   prm1,$06	; $06:    
rcall WaitBusy	;   -  
rcall SendCom	;  	
rcall wait5ms
ret
;***********************************************************************************
;    
;***********************************************************************************
Wait50us: ;    = 8 
ldi   time,130			;  
Wait51:
dec   time
brne  Wait51
ret

Wait8us: ;    = 8 
ldi   time,5			;  
Wait8:
dec   time
brne  Wait8
ret

Wait5ms: ;    = 8 
ldi   tmp2,100		  ;  
Wait53:
rcall wait50us
dec   tmp2
brne  Wait53
ret

Wait500: ;   500 
ldi   tmp1,0	    ;   
out   TCNT0,tmp1	;  T/C0
ldi   tmp1,1<<TOV0	;     TOV0
out   TIFR,tmp1	    ;   TOV0
ldi   tmp2,16 	    ; 16   
Wait:
in    tmp1,TIFR	    ;    TIFR
sbrs  tmp1,TOV0	    ;   ,   - 
rjmp  Wait	        ;   
ldi   tmp1,1<<TOV0	;     TOV0
out   TIFR,tmp1	    ;   TOV0 
dec   tmp2
brne  Wait	        ; 16  = 500 
ret
;***********************************************************************************

Start: ;   

ldi   tmp1,ADMXi        ;      "I"  
out   ADMUX,tmp1
ldi   tmp1,ADSM          ;      
out   ADCSRA,tmp1
ldi  tmp1,(1<<SE)+(1<<SM0);  "" 
out  MCUCR,tmp1
sleep                   ;   
in   tmp3,ADCL          ;   -
in   tmp2,ADCH          ;   -
ldi  tmp1,0b00001110    ;   
out  ADCSRA,tmp1
cp tmp3,CompL	;        () 
cpc tmp2,CompH
brsh Res				;   ,   
cbi PORTD,1				;   
sbi PORTD,3				;  HL2 - 
rjmp Main				;    
Res:
cbi PORTD,3				;  HL2 - 
rcall WarnI  			;   
rcall Wait500			;  0,5 

rjmp Start 				;  

Main:    ;  

cbi PORTD,4		 ;  HL2 - 	
rcall Read_ADC   ;     ADC,    
rcall Data_DisplayUI ;      
rjmp Measur_PT   ;       
Main1:
sbis PIND,2			 ;  SB1,     
rjmp Data_DisplayPT ;   ,   
rjmp Main

Read_ADC: ;    

ldi   tmp1,ADMXu         ;      "U" 
out   ADMUX,tmp1
ldi   tmp1,ADSM          ;      
out   ADCSRA,tmp1
ldi  tmp1,(1<<SE)+(1<<SM0);  "" 
out  MCUCR,tmp1
sleep                   ;   
in   tmp1,ADCL           ;   -
in   tmp2,ADCH           ;   -
sts SD1u,tmp1			 ;    ,    
sts SD2u,tmp2			 ;    
ldi  tmp1,0b00001110     ;   
out  ADCSRA,tmp1
ldi   tmp1,ADMXi        ;      "I"  
out   ADMUX,tmp1
ldi   tmp1,ADSM          ;      
out   ADCSRA,tmp1
ldi  tmp1,(1<<SE)+(1<<SM0);  "" 
out  MCUCR,tmp1
sleep                   ;   
in   tmp1,ADCL          ;   -
in   tmp2,ADCH          ;   -
sts SD1i,tmp1		    ;    ,    
sts SD2i,tmp2		    ;    
ldi  tmp1,0b00001110    ;   
out  ADCSRA,tmp1
lds HexL,SD1u			 ;    ,    
lds HexH,SD2u			 ;    
rcall HexBCDmU	         ;   BCD-
rcall CalcI				 ;   
rcall HexBCDmI	         ;   BCD-
ret

Measur_PT: ;  ,      

rcall CalcPower 	;     
cpi ChoiceT,175
breq MPT0
rcall ConvTemp  	;   
rcall ReadTemp  	;  
rjmp MPT1
MPT0:
rcall ConvTempB  	;   , DS18B20
rcall ReadTempB  	;  , DS18B20
rcall ConvByteB     ;   , DS18B20
MPT1:
rcall TempBCD    	;    BCD-
rcall CalcTherm     ;   
cpi ThermJ,Tmax     ;      
brsh Heat           ;   ,   
rjmp Main1
Heat:
sbi PORTD,1			;   
sbi PORTD,4			;  HL2 - 
cbi PORTD,3			;  HL2 - 
rcall WarnT 		;   ,  
rcall Sound         ;   
rjmp Heat           

HexBCDmU:	    ;   BCD-
rcall Div10m	; hexH:hexL / 10,  -  tmp1
sts SU1,tmp1
rcall Div10m	;  =  2
sts SU2,tmp1
rcall Div10m	;  =  3
sts SU3,tmp1
ret

HexBCDmI:	    ;   BCD-
rcall Div10m	; hexH:hexL / 10,  -  tmp1
sts SI1,tmp1
rcall Div10m	;  =  2
sts SI2,tmp1
ret

HexBCDmP:	    ;   BCD-
rcall Div10m	; hexH:hexL / 10,  -  tmp1
sts SP1,tmp1
rcall Div10m	;  =  2
sts SP2,tmp1
rcall Div10m	;  =  3
sts SP3,tmp1
ret

Div10m:	        ;  hexH:hexL  10,
	            ;    hexH:hexL,  -  tmp1
clr  tmp1
lsl  hexL
rol  hexH
rol  tmp1       ;      10
lsl  hexL	    ;       
rol  hexH   	;    0
rol  tmp1
lsl  hexL
rol  hexH
rol  tmp1
lsl  hexL
rol  hexH
rol  tmp1
lsl  hexL
rol  hexH
rol  tmp1
lsl  hexL
rol  hexH
rol  tmp1
ldi  cnt,10	    ;    10 
Loop10m:
lsl  hexL	    ;     1 
rol  hexH
rol  tmp1    	;   tmp1
subi tmp1,10	; :  > 10 ?
brlo HBm1   	    ; ,  
inc  hexL       ;     1
rjmp HBm2
HBm1:
subi tmp1,-10	;   
HBm2:
dec  cnt    	;   
brne Loop10m	; ,     
ret
;**************************************************************************************
Sound:     ;  

cbi PORTD,0
nop
ldi XL,100
Sound0:
sbi DDRD,0          ;     1,  
rcall Wait05ms      ;   
cbi DDRD,0          ;     0,   
rcall Wait05ms      ;   
dec XL
brne Sound0
sbi PORTD,0
nop
sbi DDRD,0
ret 

Wait05ms:	    ;    = 8,0 
ldi  tim1,10    ;  
Wait502:
rcall wait50us
dec   tim1
brne  Wait502
ret
;**************************************************************************************
Data_DisplayUI:;   ,   

ldi   prm1,$0C	 ;  , .   
rcall WaitBusy	 ;   -  
rcall SendCom	 ;  
ldi   prm1,$01	 ;  ,    
rcall WaitBusy	 ;   -  
rcall SendCom	 ;  
lds   prm1,SU3    ;  
ori prm1,$30
rcall WaitBusy	;   -  
rcall SendDat    ;  
lds   prm1,SU2   ;  
ori prm1,$30
rcall WaitBusy	;   -  
rcall SendDat    ;  
ldi   prm1,$2C    ; ","
rcall WaitBusy	;   -  
rcall SendDat    ;  
lds   prm1,SU1   ; 1/10 
ori prm1,$30
rcall WaitBusy	;   -  
rcall SendDat    ;  
ldi   prm1,$42    ; ""
rcall WaitBusy	;   -  
rcall SendDat    ;  
ldi   prm1,$20    ; ""
rcall WaitBusy	;   -  
rcall SendDat    ;  
lds   prm1,SI2    ;  
ori prm1,$30
rcall WaitBusy	;   -  
rcall SendDat    ;  
ldi   prm1,$2C    ; ","
rcall WaitBusy	;   -  
rcall SendDat    ;  
ldi   prm1,$40	  ;  =    
sbr   prm1,1<<7	  ;   7,  DDRAM
rcall WaitBusy	  ;   -  
rcall SendCom	  ;  
lds   prm1,SI1   ; 1/10 
ori prm1,$30
rcall WaitBusy	;   -  
rcall SendDat    ;  
ldi   prm1,$41    ; ""
rcall WaitBusy	;   -  
rcall SendDat    ;  
rcall Wait500     ;  0,5 
ret

Data_DisplayPT:;   ,   

rcall Read_ADC      ;     ADC,    
rcall CalcPower 	;     
cpi ChoiceT,175
breq MPT2
rcall ConvTemp  	;   
rcall ReadTemp  	;  
rjmp MPT3
MPT2:
rcall ConvTempB  	;   , DS18B20
rcall ReadTempB  	;  , DS18B20
rcall ConvByteB     ;   , DS18B20
MPT3:
rcall TempBCD    	;    BCD-
rcall CalcTherm     ;   
cpi ThermJ,Tmax     ;      
brsh Heat2           ;   ,   
rjmp DDPT
Heat2:
sbi PORTD,1			;   
sbi PORTD,4			;  HL2 - 
cbi PORTD,3			;  HL2 - 
rcall WarnT 		;   ,  
rcall Sound         ;   
rjmp Heat2           
DDPT:
ldi   prm1,$0C	 ;  , .   
rcall WaitBusy	 ;   -  
rcall SendCom	 ;  
ldi   prm1,$01	 ;  ,    
rcall WaitBusy	 ;   -  
rcall SendCom	 ;  
lds   prm1,SP3    ;  
ori prm1,$30
rcall WaitBusy	;   -  
rcall SendDat    ;  
lds   prm1,SP2   ;  
ori prm1,$30
rcall WaitBusy	;   -  
rcall SendDat    ;  
lds   prm1,SP1   ;  
ori prm1,$30
rcall WaitBusy	;   -  
rcall SendDat    ;  
ldi   prm1,$57    ; "W"
rcall WaitBusy	;   -  
rcall SendDat    ;  
ldi   prm1,$20    ; ""
rcall WaitBusy	;   -  
rcall SendDat    ;  
lds   prm1,ST3   ;  
ori prm1,$30
rcall WaitBusy	;   -  
rcall SendDat    ;  
lds   prm1,ST2   ;  
ori prm1,$30
rcall WaitBusy	;   -  
rcall SendDat    ;  
lds   prm1,ST1   ;  
ori prm1,$30
rcall WaitBusy	;   -  
rcall SendDat    ;  
ldi   prm1,$40	  ;  =    
sbr   prm1,1<<7	  ;   7,  DDRAM
rcall WaitBusy	  ;   -  
rcall SendCom	  ;  
ldi   prm1,$99   ;  
rcall WaitBusy	;   -  
rcall SendDat    ;  
ldi   prm1,$43    ; "C"
rcall WaitBusy	;   -  
rcall SendDat    ;  
rcall Wait500     ;  0,5 
sbic PIND,2		  ;  SB1, 
rjmp Data_DisplayPT ;  
rcall Wait500     ;  0,5 
rjmp Main           ; 

WarnT:;   ,  

ldi   prm1,$0C	 ;  , .   
rcall WaitBusy	 ;   -  
rcall SendCom	 ;  
ldi   prm1,$01	 ;  ,    
rcall WaitBusy	 ;   -  
rcall SendCom	 ;  
ldi   prm1,$A8   ; ""
rcall WaitBusy	;   -  
rcall SendDat    ;  
ldi   prm1,$65   ; ""
rcall WaitBusy	;   -  
rcall SendDat    ;  
ldi   prm1,$70   ; ""
rcall WaitBusy	;   -  
rcall SendDat    ;  
ldi   prm1,$65   ; ""
rcall WaitBusy	;   -  
rcall SendDat    ;  
ldi   prm1,$B4   ; ""
rcall WaitBusy	;   -  
rcall SendDat    ;  
ldi   prm1,$70   ; ""
rcall WaitBusy	;   -  
rcall SendDat    ;  
ldi   prm1,$65   ; ""
rcall WaitBusy	;   -  
rcall SendDat    ;  
ldi   prm1,$B3   ; ""
rcall WaitBusy	;   -  
rcall SendDat    ;  
ldi   prm1,$40	  ;  =    
sbr   prm1,1<<7	  ;   7,  DDRAM
rcall WaitBusy	  ;   -  
rcall SendCom	  ;  
ldi   prm1,$21   ; "!"
rcall WaitBusy	;   -  
rcall SendDat    ;  
ldi   prm1,$21   ; "!
rcall WaitBusy	;   -  
rcall SendDat    ;  
rcall Wait500     ;  0,5 
ret

WarnI:;   ,   

ldi   prm1,$0C	 ;  , .   
rcall WaitBusy	 ;   -  
rcall SendCom	 ;  
ldi   prm1,$01	 ;  ,    
rcall WaitBusy	 ;   -  
rcall SendCom	 ;  
ldi   prm1,$50   ; ""
rcall WaitBusy	;   -  
rcall SendDat    ;  
ldi   prm1,$65   ; ""
rcall WaitBusy	;   -  
rcall SendDat    ;  
ldi   prm1,$B7   ; ""
rcall WaitBusy	;   -  
rcall SendDat    ;  
ldi   prm1,$B8   ; ""
rcall WaitBusy	;   -  
rcall SendDat    ;  
ldi   prm1,$63   ; ""
rcall WaitBusy	;   -  
rcall SendDat    ;  
ldi   prm1,$BF   ; ""
rcall WaitBusy	;   -  
rcall SendDat    ;  
ldi   prm1,$6F   ; ""
rcall WaitBusy	;   -  
rcall SendDat    ;  
ldi   prm1,$70   ; ""
rcall WaitBusy	;   -  
rcall SendDat    ;  
ldi   prm1,$40	  ;  =    
sbr   prm1,1<<7	  ;   7,  DDRAM
rcall WaitBusy	  ;   -  
rcall SendCom	  ;  
ldi   prm1,$21   ; "!"
rcall WaitBusy	;   -  
rcall SendDat    ;  
ldi   prm1,$21   ; "!"
rcall WaitBusy	;   -  
rcall SendDat    ;  
ret

MUL42:          ;  
ldi  tmp1,0x10
MUL1:               ; , m3:m2 * m1:m0
mov  tmp2,m2          ;   m7:m6:m5:m4
ror  tmp2           
brcc  MUL2        
mov  tmp2,m6
add  tmp2,m0
mov  m6,tmp2
mov  tmp2,m7
adc  tmp2,m1
mov  m7,tmp2
MUL2:
mov  tmp2,m7
ror  tmp2
mov  m7,tmp2
mov  tmp2,m6
ror  tmp2
mov  m6,tmp2
mov  tmp2,m5
ror  tmp2
mov  m5,tmp2
mov  tmp2,m4
ror  tmp2
mov  m4,tmp2
mov  tmp2,m3
ror  tmp2
mov  m3,tmp2
mov  tmp2,m2
ror  tmp2
mov  m2,tmp2
dec  tmp1
cpi  tmp1,0
brne MUL1
ret

DIV42:        ;  
ldi  tmp1,0x10
DCLK42:             ;   m7:m6:m5:m4
clc                 ;   m1:m0
mov  tmp2,m4          ;   m5:m4
rol  tmp2
mov  m4,tmp2
mov  tmp2,m5
rol  tmp2
mov  m5,tmp2
mov  tmp2,m6
rol  tmp2
mov  m6,tmp2
mov  tmp2,m7
rol  tmp2
mov  m7,tmp2
in   Cnt,SREG
push Cnt
PER1:
clc
mov  tmp2,m6
sbc  tmp2,m0
mov  m6,tmp2
mov  tmp2,m7
sbc  tmp2,m1
mov  m7,tmp2
brcs PER2
pop  Cnt
out  SREG,Cnt
PER3:
inc m4
rjmp PER4
PER2:
pop  Cnt
out  SREG,Cnt
brcs PER3
mov  tmp2,m6
add  tmp2,m0
mov  m6,tmp2
mov  tmp2,m7
adc  tmp2,m1
mov  m7,tmp2
PER4:
dec  tmp1
cpi  tmp1,0
brne DCLK42
ret

CalcI: ;  

lds m0,SD1i          ;    
lds m1,SD2i
ldi tmp1,$15
mov m2,tmp1			 ;  277
ldi tmp1,$01
mov m3,tmp1
ldi tmp1,0           ;        
mov m4,tmp1
mov m5,tmp1
mov m6,tmp1
mov m7,tmp1

rcall MUL42

ldi tmp1,$E8          ;    1000
mov m0,tmp1                
ldi tmp1,$03
mov m1,tmp1

rcall DIV42

mov hexL,m4			;       BCD-
mov hexH,m5

sts SP1i,m4			;     
sts SP2i,m5
ret

CalcPower:;     

lds m0,SP1i          ;    
lds m1,SP2i
lds m2,SD1u			 ;    
lds m3,SD2u
ldi tmp1,0            ;        
mov m4,tmp1
mov m5,tmp1
mov m6,tmp1
mov m7,tmp1

rcall MUL42

ldi tmp1,$64          ;    100=$64
mov m0,tmp1                
ldi tmp1,0
mov m1,tmp1

rcall DIV42

mov hexL,m4			;       BCD-
mov hexH,m5
mov m2,m4           ;        
mov m3,m5
rcall HexBCDmP	    ;   BCD-
ret

CalcTherm: ;   

ldi tmp1,75
mov m0,tmp1          ;   "-"
ldi tmp1,0			 ; 0,75 C/W*100
mov m1,tmp1          
ldi tmp1,0            ;        
mov m4,tmp1
mov m5,tmp1
mov m6,tmp1
mov m7,tmp1

rcall MUL42

ldi tmp1,$64          ;    100=$64
mov m0,tmp1                
ldi tmp1,0
mov m1,tmp1

rcall DIV42

add ThermJ,m4		  ;  
ret

Microlan: ;  1Wire
;****************************************************************************
;      1-Wire
;****************************************************************************
Wait5us:	    ;    = 8,0 
ldi   tim1,10	;  
Wait501:
dec   tim1
brne  Wait501
nop
nop
nop
ret

Wait65us:	    ;    = 8,0 
ldi   tim1,170	;  
Wait565:
dec   tim1
brne  Wait565
nop
nop
nop
ret
	 
WaitML:	        ;    = 8,0 
rcall wait5us
dec   tmp2
brne  WaitML
ret
;**********************************************************************************
ResML:    ;   

sbi DDRC,DQ       ; '' 
ldi tmp2,130
rcall WaitML      ;  700 
cbi DDRC,DQ       ; '' 
rcall Wait65us    ;  65
sbic PINC,DQ      ;   2  C
rjmp RM0          ;   ,  0
ldi tmp2,93
rcall WaitML      ;  500 
sbis PINC,DQ      ;   2  C
rjmp RM1
ret               
RM0: 
ret
RM1: 
ret

RdSlot:  ;  

sbi DDRC,DQ      ; '' 
nop
nop
nop
nop
nop
nop
nop
nop
nop
nop
cbi DDRC,DQ      ; '' 
nop
nop
nop
nop
nop
nop
nop
nop
nop
nop
ldi tmp2,2
rcall WaitML      ;  13 
sbis PINC,DQ      ;   2  C
rjmp RS0          ;  ,  1
sec               ;  , '1'
ldi tmp2,11
rcall WaitML      ;  60
ret
RS0:
clc               ;  , '0'
ldi tmp2,11
rcall WaitML      ;  60
ret

WrSlotL:  ;  '0'  

sbi DDRC,DQ      ; '' 
ldi tmp2,15
rcall WaitML     ;  80 
cbi DDRC,DQ      ; '' 
ret

WrSlotH:  ;  '1'  

sbi DDRC,DQ      ; '' 
rcall Wait5us
cbi DDRC,DQ      ; '' 
ldi tmp2,14
rcall WaitML     ;  75 
ret

Wr8ML:    ;  

ldi tmp1,8        ;  
WM0:
ror hexH          ;      
brcs WM1          ; ,  C=1
rcall WrSlotL     ;  '0'  
rjmp WM2
WM1:
rcall WrSlotH     ;  '1'  
WM2:
dec tmp1
brne WM0          ; ,   
ret

Wr1ML:    ;  

in tmp1,SREG      ;   
sbrs tmp1,0
rjmp WM5          ; ,  C=0
rcall WrSlotH     ;  '1'  
ret
WM5:
rcall WrSlotL     ;  '0'  
ret

Rd8ML:    ;  

ldi tmp1,8        ;  
WM6:
rcall RdSlot      ;  
ror hexH          ;      
dec tmp1
brne WM6          ; ,            
ret

Rd1ML:    ;  

rcall RdSlot      ;  
ret
;**********************************************************************************
ReadCodID:    ;  ID-    1-Wire

rcall ResML       ;    
ldi tmp1,$33      ;  ' '
mov hexH,tmp1     
rcall Wr8ML       ;  
rcall Rd8ML       ;  
mov tmp1,hexH
cpi tmp1,$28      ;  ,  DS18B20
breq RCD
ret
RCD:
ldi ChoiceT,175   ;    
ret

ConvTempB:  ;   

rcall ResML       ;    
ldi tmp1,$CC
mov hexH,tmp1       ;  
rcall Wr8ML       ;  
ldi tmp1,$44
mov hexH,tmp1       ;  
rcall Wr8ML       ;  
WD3b:
rcall Rd1ML       ;  
brcs WD4b          ; ,  C=1
rjmp WD3b          ;    
WD4b:
ret

ReadTempB:  ;  

rcall ResML       ;    
ldi tmp1,$CC
mov hexH,tmp1       ;  
rcall Wr8ML       ;  
ldi tmp1,$BE        ;   
mov hexH,tmp1
rcall Wr8ML       ;  
rcall Rd8ML       ;   
mov hexL,hexH     ;   
rcall Rd8ML       ;   
ret

ConvByteB:  ;   , DS18B20

mov tmp1,hexL       ;   
mov tmp2,hexH       ;   
swap tmp2           ;   
andi tmp2,$F0       ;   
swap tmp1           ;   
andi tmp1,$0F       ;   
or tmp2,tmp1          ;  
mov hexL,tmp2       ;   
mov ThermJ,tmp2     ;     
ldi tmp1,0
mov hexH,tmp1		;   
ret

ConvTemp:  ;   

rcall ResML       ;    
ldi tmp1,$CC
mov hexH,tmp1       ;  
rcall Wr8ML       ;  
ldi tmp1,$44
mov hexH,tmp1       ;  
rcall Wr8ML       ;  
WD3:
rcall Rd1ML       ;  
brcs WD4          ; ,  C=1
rjmp WD3          ;    
WD4:
ret

ReadTemp:  ;  

rcall ResML       ;    
ldi tmp1,$CC
mov hexH,tmp1       ;  
rcall Wr8ML       ;  
ldi tmp1,$BE        ;   
mov hexH,tmp1
rcall Wr8ML       ;  
rcall Rd8ML       ;   
mov tmp1,hexH       ;   
lsr tmp1            ;    
mov hexL,tmp1       ;   
mov ThermJ,tmp1     ;     
ldi tmp1,0
mov hexH,tmp1		;   
ret

TempBCD: ;    BCD-
rcall Div10m	; hexH:hexL / 10,  -  tmp1
sts ST1,tmp1	;   hexH, tmp1  ST1
rcall Div10m	;  =  2
sts ST2,tmp1	;   hexH, tmp1  ST2
rcall Div10m	;  =  3
sts ST3,tmp1	;   hexH, tmp1  ST3
ret

;****************************************************************************
.dseg


SP1:.byte 1     ;    , BCD-
SP2:.byte 1      
SP3:.byte 1      
SD1i:.byte 1    ;     , hex- 
SD2i:.byte 1     
SD1u:.byte 1    ;     , hex- 
SD2u:.byte 1     
SU1:.byte 1     ;    , BCD-
SU2:.byte 1    
SU3:.byte 1    
SI1:.byte 1     ;    , BCD-
SI2:.byte 1
ST1:.byte 1     ;    , BCD-
ST2:.byte 1    
ST3:.byte 1
SP1i:.byte 1    ;     , hex- 
SP2i:.byte 1 



.EXIT




